unit NeuKnotM;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, VirtualTrees;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    il20: TImageList;
    vt: TVirtualStringTree;
    procedure Button1Click(Sender: TObject);
    procedure vtGetNodeDataSize(Sender: TBaseVirtualTree;
      var NodeDataSize: Integer);
    procedure vtGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType; var CellText: String);
  private

  public

  end;

var
  Form1: TForm1;

implementation
{$R *.lfm}
type
  PNodeStrings = ^TStringList;

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var P: PNodeStrings;
    Strings: TStringList;
    Node: PVirtualNode;
    I: Integer;
    S: string;
begin
  if InputQuery('Titel bestimmen', 'Titel:', S) then
  begin
    Node := vt.AddChild(vt.FocusedNode);
    P := vt.GetNodeData(Node);
    Strings := TStringList.Create;
    for I := 0 to vt.Header.Columns.Count-1 do
      Strings.Add('');
    Strings[3] := S;
    Strings[5] := '1';
    Strings[7] := '1';
    P^ := Strings;
    vt.Expanded[vt.FocusedNode] := True;
  end;
end;

procedure TForm1.vtGetNodeDataSize(Sender: TBaseVirtualTree; var NodeDataSize: Integer);
begin
  NodeDataSize := SizeOf(PNodeStrings);
end;

procedure TForm1.vtGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
          Column: TColumnIndex; TextType: TVSTTextType; var CellText: String);
var P: PNodeStrings;
    Strings: TStringList;
begin
  P := Sender.GetNodeData(Node);
  Strings := TStringList(P^);
  CellText := Strings[Column];
end;

end.

